const router = require('express').Router();
const homeController = require('../controller/home.js');
const dash = require('../controller/dashboard.js');
const api = require('../controller/api.js');
module.exports = (io, bot)=>
{
    router.route('/redirect').get(homeController.redirect)
    router.route('/dc').get(homeController.dc);
    router.route('/addtodiscord').get(homeController.addtodiscord)

    router.route('/').get(api.home)
    router.route('/redirect').get(api.redirect)
    router.route('/dashboard').get(api.dashboard(bot))
    router.route('/moderator/:moderatorid?').get(api.dashboard(bot))
    router.route('/gdash/:id/:setting?').get(api.gDash(bot))
                                        .put(api.guildUpdate(bot))
    router.route('/feedsdash/:guildid').get(api.fDash(bot));
    router.route('/feedChange/:id/:guildid?').get(api.feedChange(bot))
                                             .delete(api.deleteFeed(bot))
                                             .put(api.updateFeed(bot));
    router.route('/newFeed/:guildid').get(api.addFeed(bot))
                                     .put(api.saveNewFeed(bot));
                                     

    router.route('/rolerulesdash/:id').get(api.rDash(bot))
    router.route('/rolechange/:id?/:guildid?').get(api.roleChange(bot))
                                            .put(api.saveRoleChange(bot))
                                            .delete(api.deleteRole)
    router.route('/newrule').put(api.newRule(bot))
    
    router.route('/newrolerule/:guildid').get(api.newRoleRule(bot))
    router.route('/guilds').get(api.guilds(bot));
    router.route('/pp').get(api.pp);
    router.route('/tos').get(api.tos);
    router.route('/api/torrent/:name/:size/:category/:id').post(api.torrent(bot));

    router.route('/strikes/:id/:userid/:strikeid?').get(api.strikeDashboard(bot))
                                                   .put(api.updateStrikes(bot))
                                                   .delete(api.deleteStrikes(bot));
                                                   
    return router;
};